;; Problem 67
;; 09 April 2004
;; By starting at the top of the triangle below and moving to adjacent numbers on the row below, the maximum total from top to bottom is 23.
;; 3
;;  7 5
;;  2 4 6
;;  8 5 9 3
;; That is, 3 + 7 + 4 + 9 = 23.
;; Find the maximum total from top to bottom in triangle.txt (right click and 'Save Link/Target As...'), a 15K text file containing a triangle with one-hundred rows.
;; NOTE: This is a much more difficult version of Problem 18. It is not possible to try every route to solve this problem, as there are 299 altogether! If you could check one trillion (1012) routes every second it would take over twenty billion years to check them all. There is an efficient algorithm to solve it. ;o)


(defun get-upper-idxs (lower-idx upper-len)
  (cond ((= 0 lower-idx)
	 (list lower-idx))
	((= lower-idx upper-len)
	 (list (- lower-idx 1)))
	(t
	 (list (- lower-idx 1)
	       lower-idx))))

;; merge upper into lower, taking the max of the sums from the pairs
(defun combine-rows (upper-row lower-row)
  (loop for litem in lower-row
	for lidx = 0 then (+ lidx 1)
	collect
	(apply #'max
	       (loop for uidx in (get-upper-idxs lidx (length upper-row))
		     collect (+ (nth lidx lower-row)
				(nth uidx upper-row))))))

(defun collapse-triangle (triangle)
  (let* ((current-row (first triangle)))
    (loop for next-row in (rest triangle)
	  do
	  (setf current-row (combine-rows current-row next-row)))
    current-row))

(defun get-huge-triangle ()
  (with-open-file (inp "triangle.txt" :direction :input)
    (loop for line = (read-line inp nil nil)
	  while line
	  collect (read-from-string (concatenate 'string "(" line ")")))))

(apply #'max (collapse-triangle (get-huge-triangle))); 7273